/*
 * File:   newmain.c
 * Author: win7
 *
 * Created on 2016?8?27?, ?? 10:37
 */


#include <xc.h>
#include <htc.h>

#define HOUR_1 3600
#define HOUR_2 7200
#define MIN_5  360
#define MIN_10 720

#define _XTAL_FREQ  4000000      // oscillator frequency for _delay()
#pragma config WDTE=ON , BOREN=OFF , PWRTE=ON , MCLRE=OFF , FOSC=INTRCIO
#pragma config WDTPS=0    // Watchdog Timer Postscale Select bits (1:32768)

void  interrupt ISR()
{
    GPIF=0; //Clear the interrupt bit, or keep interrupted
}

void main() {
    int remain_timer = 0;
    int t;
    int wakeup=0;
    
   // ANSEL = 0b00000000;
    

    TRISIO    = 0b111010;  
    ADCON0=0b111;
    ANSEL=0;
    CMCON=7;
    
    GPIO=4;
    __delay_ms(1000);
    GPIO=0;
    
    GIE=0;
    GPIE=1;
    IOC1=1;

    while (1) {
        

        if(remain_timer == 0) {
			/* Interrupt-on-change detection is based on last read */	
            GPIO=0;
             __delay_ms(100);
            t=GPIO;
            GPIF=0;
            GIE=1;
            SLEEP();
            GIE=0;
			/* somehow, we can't get correct GP1 after wakeup */
			/* Add a flag to indicate this */
            wakeup = 1; 
            
            
        }
        //if(GP1) {
        if(GP1 || wakeup) {
            wakeup = 0;
            __delay_ms(100);
            remain_timer = HOUR_1;
            GPIO=5;
        }
        
        if((remain_timer > 0) && (remain_timer < MIN_5)) {
            if(remain_timer & 1)
                GPIO=5;
            else
                GPIO=1;
        }
        if (remain_timer > 0)
            remain_timer--;
        




        __delay_ms(1000);
    }
    

}
